

/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _ContentDialog_h_
#define _ContentDialog_h_

#include "rafport.h"


#include "illum.h" // for DAFS Type and idTag
#include "ModalDialog.h"  // we are subclassed
#include "aString.h"
#include "misc/misc.h" // for MenuItem

class ContentDialog : public ModalDialog {
public:
	Widget separator;
	Widget frame;
	Widget type_menu;
	MenuItem *menu;

	// an area indexed by type of widget to be managed
	// there can be duplicates
	Widget *content_widgets;

	int max_tag; // how big the menu is
	aString title;
	int tag; // type of data current display
	int changed;

	ContentDialog(MainWindow *mw, Widget w, XtAppContext app_context,
				  MenuItem *menu, int max_tag, char *title);
	~ContentDialog();

	/*virtual*/ void create();

	void createBase();
	void createDefault();
	void setType(int tag);
	void showModal();

	virtual void createCustom() = 0;
	virtual void getFromDialog() = 0;
	virtual void putInDialog() = 0;

	void okCB(XmFileSelectionBoxCallbackStruct *cbs);
	void cancelCB(XmFileSelectionBoxCallbackStruct *cbs);
};

void cdSetType(Widget w, int tag, XtPointer call_data);
struct xmtvcbs;
void verify_short(Widget w,  void *user_data, xmtvcbs *cbs);
void verify_long(Widget w,  void *user_data, xmtvcbs *cbs);
void verify_value(Widget w,  void *user_data, xmtvcbs *cbs);


#endif
