

/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _ListDialog_h_
#define _ListDialog_h_

#include "aString.h"
#include "ModalDialog.h"  // we are subclassed

typedef int (*selCBProc)(void *,char *);

class ListDialog : public ModalDialog {
public:
	void *user_data;
	selCBProc call_back;
	aString answer;
	XmString title;
	
	ListDialog(MainWindow *mw, Widget w, XtAppContext app_context, 
			   XmString title, selCBProc CB, void *CBdata);

	~ListDialog();
	/*virtual*/ void create();

	//kind of a mess
	void show(XmStringTable table, int size);
	aString showModal(XmStringTable table, int size);
	void change(XmStringTable table, int size);
	char *getString(XmFileSelectionBoxCallbackStruct *cbs);

	void okCB(XmFileSelectionBoxCallbackStruct *cbs);
	void applyCB(XmFileSelectionBoxCallbackStruct *cbs);
	void cancelCB(XmFileSelectionBoxCallbackStruct *cbs);
};

#endif
