
/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */


#ifndef _MainWindow_cb_h_
#define _MainWindow_cb_h_

enum MagLevel {
	mlQUARTER,
	mlHALF,
	mlNORMAL,
	mlDOUBLE,
	mlQUADRUPLE,
};

void entitySortCB (Widget    w,
					   MainWindow *mw,
					   void *call);

void entityGrowHorzCB (Widget    w,
					   MainWindow *mw,
					   void *call);


void entityShrinkHorzCB (Widget    w,
						 MainWindow *mw,
						 void *call);

void entityMoveRightCB (Widget    w,
						MainWindow *mw,
						void *call);

void entityMoveLeftCB (Widget    w,
					   MainWindow *mw,
					   void *call);


void entityGrowVertCB (Widget    w,
					   MainWindow *mw,
					   void *call);

void entityShrinkVertCB (Widget    w,
						 MainWindow *mw,
						 void *call);

void entityMoveUpCB (Widget    w,
					 MainWindow *mw,
					 void *call);

void entityMoveDownCB (Widget    w,
					   MainWindow *mw,
					   void *call);

#ifdef RAF_INTERNAL

void whiteEntityCB(Widget,
				   MainWindow *mw,
				   void *call);


void pitchGrowHorzCB (Widget    w,
					  MainWindow *mw,
					  void *call);
void 
pitchShrinkHorzCB (Widget    w,
				   MainWindow *mw,
				   void *call);

void 
pitchMoveRightCB (Widget    w,
				  MainWindow *mw,
				  void *call);

void 
pitchMoveLeftCB (Widget    w,
				 MainWindow *mw,
				 void *call);
void 
pitchGrowVertCB (Widget    w,
				 MainWindow *mw,
				 void *call);
void 
pitchShrinkVertCB (Widget    w,
				   MainWindow *mw,
				   void *call);
void 
pitchMoveUpCB (Widget    w,
			   MainWindow *mw,
			   void *call);
void 
pitchMoveDownCB (Widget    w,
				 MainWindow *mw,
				 void *call);

#endif

void AboutCB (Widget    w,
			  MainWindow *mw,
			  void *call);

void ClearFlagCB(Widget w,
				 MainWindow *data,
				 XtPointer call_data);

/* bogus -- replace with Language callback */
#if 0
void LanguageCB(Widget w,
				Tuple *data,
				XtPointer call_data);
#else
void AmericanCB(Widget    w,
				MainWindow *window,
				XtPointer    call_data);

void ArabicCB(Widget     w,
			  MainWindow  *window,
			  XtPointer     call_data);

void RussianCB(Widget    w,
			   MainWindow *window,
			   XtPointer    call_data);

void EnglishCB(Widget    w,
			   MainWindow *window,
			   XtPointer    call_data);

void GermanCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void SwedishCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void NorwCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void SpanishCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void ItalianCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void FrenchCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void GreekCB(Widget    w,
			 MainWindow *window,
			 XtPointer    call_data);

void MicrCB(Widget    w,
			 MainWindow *window,
			 XtPointer    call_data);
#endif

#ifdef RAF_INTERNAL
void ReinitializeCB(Widget    w,
					MainWindow *window,
					XtPointer    call_data);
#endif

#ifdef RAF_INTERNAL
void classCB(Widget w,
			 Tuple *data,
			 XtPointer call_data);
#endif

void viewCB(Widget w,
			MainWindow *mw,
			XtPointer call_data);

#ifdef RAF_INTERNAL
void recognizeCB(Widget w,
				 MainWindow *mw,
				 XtPointer call_data);
void deleteChildrenCB(Widget w,
					  MainWindow *mw,
					  XtPointer call_data);
void deskewCB(Widget w,
			  MainWindow *mw,
			  XtPointer call_data);
void steves_specialCB(Widget w,
					  MainWindow *mw,
					  XtPointer call_data);
#endif

void KeyboardCB(Widget    w,
				MainWindow *window,
				XtPointer    call_data);

void ChooseCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void ColorsCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

void TypePrefCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);

#ifdef DO_POPUPS
void FlagCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);
#endif

void TextCB(Widget    w,
			MainWindow *window,
			XtPointer    call_data);

void NextEntityCB(Widget    w,
				  MainWindow *window,
				  XtPointer    call_data);

void PrevEntityCB(Widget    w,
				  MainWindow *window,
				  XtPointer    call_data);

#ifdef RAF_INTERNAL
void BrokenCB(Widget    w,
			  MainWindow *window,
			  XtPointer    call_data);


void UnknownTypeCB(Widget    w,
				   MainWindow *window,
				   XtPointer    call_data);

void HandTypeCB(Widget    w,
				MainWindow *window,
				XtPointer    call_data);

void FixedTypeCB(Widget    w,
				 MainWindow *window,
				 XtPointer    call_data);

void VariableTypeCB(Widget    w,
					MainWindow *window,
					XtPointer    call_data);
#endif

void MagCB(Widget w,
		   Tuple *data,
		   XtPointer    call_data);

void changeTypeCB(Widget w,
		   Tuple *data,
		   XtPointer call_data);

void QuitCB (Widget    w,
			 MainWindow *mw,
			 XtPointer    call_data);

void NewCB (Widget    w,
			MainWindow *mw,
			void *call);

void SaveCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void SaveAsCB (Widget    w,
			   MainWindow *mw,
			   void *call);

void OpenCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void RevertCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void SelectCB (Widget    w,
			   MainWindow *mw,
			   void *call);

void ForwardCB (Widget    w,
				MainWindow *mw,
				void *call);

void BackCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void NextCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void PrevCB (Widget    w,
			 MainWindow *mw,
			 void *call);
void pageUpCB (Widget    w,
			 MainWindow *mw,
			 void *call);
void pageDownCB (Widget    w,
			 MainWindow *mw,
			 void *call);
void pageRightCB (Widget    w,
			 MainWindow *mw,
			 void *call);
void pageLeftCB (Widget    w,
			 MainWindow *mw,
			 void *call);

void UpEntityCB (Widget    w,
				 MainWindow *mw,
				 void *call);

void DownEntityCB (Widget    w,
				   MainWindow *mw,
				   void *call);

void FindNextFlagCB (Widget    w,
				   MainWindow *mw,
				   void *call);

void ModeCB(Widget w,
			Tuple *data,
			void *call);

void rotateCB(Widget w, 
			  MainWindow *mw,
			  void *call);
			  
void centerOnSelectedCB (Widget    w,
						 MainWindow *mw,
						 void *call);

void editKillWordCB(Widget    w,
					MainWindow *mw,
					void *call);

void deleteCB (Widget    w,
			   MainWindow *mw,
			   void *call);

#ifdef RAF_INTERNAL
void joinCB (Widget    w,
			   MainWindow *mw,
			   void *call);
void splitCB (Widget    w,
			   MainWindow *mw,
			   void *call);
void delparentCB (Widget    w,
			   MainWindow *mw,
			   void *call);
void newparentCB (Widget    w,
			   MainWindow *mw,
			   void *call);
void imagepageCB (Widget    w,
			   MainWindow *mw,
			   void *call);
#endif

void ConfigureEH (Widget   shell,
				  MainWindow *mw,
				  XConfigureEvent *event,
				  char *foo);

void centerOnSelectedCB (Widget    w,
						 MainWindow *mw,
						 void *call);

#ifdef RAF_INTERNAL
void LeftPhaseCB (Widget    w,
				  MainWindow *mw,
				  void *call);

void RightPhaseCB (Widget    w,
				   MainWindow *mw,
				   void *call);

void DecrPitchCB (Widget    w,
				  MainWindow *mw,
				  void *call);

void DecrPitch (MainWindow *mw,
				int incr);

void IncrPitchCB (Widget    w,
				  MainWindow *mw,
				  void *call);
void IncrPitch (MainWindow *mw,
				int incr);
void DecrDoubleCB (Widget    w,
				   MainWindow *mw,
				   void *call);

void IncrDoubleCB (Widget    w,
				   MainWindow *mw,
				   void *call);
#endif

void newEntityCB (Widget    w,
					 MainWindow *mw,
					 void *call);

void inputUnicodeCB (Widget    w,
					 MainWindow *mw,
					 void *call);

void inputJapaneseCB(Widget    w,
					 MainWindow *mw,
					 void *call);

#endif
