
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _RTEMode_h_
#define _RTEMode_h_


#include "Mode.h"

class RTEPage;

class RTEMode : public Mode {
	// there is a dllist of pages in Mode.h
public:
	Widget page, old_page;
	Widget swindow;
public:
	RTEMode(MainWindow *mw, iEntityPtr entity);
	void findPageEntitiesSub(iEntityPtr entity, DLList *entity_list);
	void findPageEntities(iEntityPtr root_entity, DLList *entity_list);
	~RTEMode();
	
	/*virtual*/ void createPages(iEntityPtr entity);
	void createPages(DLList *entity_list);
	
	/*virtual*/ aString getName();
	/*virtual*/ ModeType getMode();
	
	/*virtual*/ void addNewEntity(iEntityPtr);
	/*virtual*/ void choose(int buttons_changed);
	/*virtual*/ void centerOnSelected(iEntityPtr entity);
	/*virtual*/ void configure();

  void processDelete(void);
};

#endif
