
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */


#ifndef _SelectionManager_h_
#define _SelectionManager_h_

#include "dllist.h"
#include "EntityAux.h"
#include "illum.h"

class SelectionManager {
private:
	MainWindow *mw;
	DLList selection;
	iEntityPtr from_entity;
	int        from_index;
	iEntityPtr to_entity;
	int        to_index;
	int        dirty;
	int range_selected;
	SelectionClass sc;

	DLList legacy_selection;
	iEntityPtr legacy_from_entity;
	int        legacy_from_index;
	iEntityPtr legacy_to_entity;
	int        legacy_to_index;
	void clearLegacy();
public:
	void _clear();
	SelectionManager(MainWindow *mw);
	~SelectionManager();
	
	SelectionClass getState();
	
	void clear();
	
	int selectedItemP(iEntityPtr item);
	int rangeSelectedP();
	
	void toggleItem(iEntityPtr item);
	void appendItem(iEntityPtr item);
	void setItem(iEntityPtr item);
	iEntityPtr getSoleItem();
	const DLList *getItems();
	
	// why does unselect exist
	int unselectChildren(iEntityPtr entity);
	void unselect(iEntityPtr entity);
	
	void getRange(iEntityPtr& from_entity, int& from_index,
				  iEntityPtr& to_entity,   int& to_index);
	void setRange(iEntityPtr from_item, 
				  int from, 
				  iEntityPtr to_item,
				  int to);
	void setRangeAdjacent(iEntityPtr from_item, 
				  int from, 
				  iEntityPtr to_item,
				  int to);

	void convertToRange(void);
	void convertToItem(void);
	void convertToTreeItem(void);
};

#if 0
#define CONTROL_POINTS
#endif


#endif
