
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _TreeElement_h_
#define _TreeElement_h_

#include "illum.h"
#include "text/EntityFace.h"

#define SPACER 5
#define MAXCHARS 10

class TreePage;
class ViewCanvas;

class TreeElement;
typedef TreeElement *TreeElementPtr;

class TreeElement : public EntityFace {
  public:
	int x,y,width,height,lev,show,kids,or_path,prev_or_path;
	iUCode *text;
	int numchars;
	// entity is in EntityFace
public:
	TreeElement(Page *page, iEntityPtr entity,int xpos,int ypos,int showval,int lev);
	virtual ~TreeElement();
public:
	void redraw();
	iLBox getBox();
	int inBox(int x,int y);
	int inTri(int x, int y);
	int inRectangle(int x,int y);
	void drawBox(Display *display, Pixmap pixmap, GC gc, iLBox *bp);
	void drawTri(Display *display, Pixmap pixmap, GC gc);
	void drawRectangle(Display *display, Pixmap pixmap, GC gc,int x, int y);
	void drawTheString(Display *display, Pixmap pixmap, int x, int y,iEntityPtr entity);
	int drawAnEntity(Display *display,Pixmap pixmap);
	void getBoxTextandWidth();
	int measureContentWidth(iUCode *buf, int num_chars);
	void getPosSet(iEntityPtr entity, iUCode *buf, int *len);
	void getString(iEntityPtr entity, iUCode *buf, int *len);
	void getUString(iEntityPtr entity, iUCode *buf, int *len);
	/*virtual*/ void deleteAndUpdate();
	/*virtual*/ void deleteCheap();
	
	/* callbacks -- EntityFace virtuals */
	/*virtual*/ void create();
	
	/*virtual*/ void willUpdate();
	/*virtual*/ void update();
	
	/*virtual*/ void willMove();
	/*virtual*/ void move();
	
	/*virtual*/ void destroy();
	
	/*virtual*/ void select();
	/*virtual*/ void unSelect();
	
	/*virtual*/ void recognize();
	
	/*virtual*/ MainWindow *getMainWindow();
	
	friend class TreePage;
};

#endif


