#ifndef _UNIWIDGET_H_
#define _UNIWIDGET_H_

// margins in 1/4 units
#define X_MARGIN 2
#define Y_MARGIN 2

#define NORMAL  0
#define REVERSE 1

// class which encapsulates a drawingarea widget and callbacks for unicode input
class UniWidget 
{
  protected:
	uString **lines;
	int line, lines_length;
	Widget da;
	GC gc;
	Pixel background_color;
	Cursor cursor;
	KeyMap *keymap;

	int insertion, base_length, overstrike, direction;
	int width, height, ascent;
	int xstart, ystart, start_pos, stop_pos, start_line, stop_line;
	int selecting, selection;
	int draw_x, draw_y;
	unsigned  draw_width, draw_height;

	void draw(void);
	void draw(int initial, int final);
	void drawBorder(void);

	void killLine(int i);
	void newLine(void);

	unsigned pos2line(int y);
	unsigned base2raw(unsigned index);
	unsigned raw2base(unsigned index);
	void pos2base(int x, int y, int *line_pos, int *base_pos);
	unsigned nonspacing(unsigned raw);

  public:
	UniWidget(Widget parent, KeyMap *km);
	~UniWidget();

	// callbacks and handlers
	void InputCallback(XmDrawingAreaCallbackStruct *cbs);
	void ExposeCallback(XmDrawingAreaCallbackStruct *cbs);
	void ResizeCallback(XmDrawingAreaCallbackStruct *cbs);
	void MotionHandler(XEvent *event);

	// access routines
	Widget getWidget(void) { return da; }
	void setString(const iUCode *string);
	iUCode *getString(void);
	void changeKeyMap(KeyMap *km);
};

#endif
