
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _Unicode_h__
#define _Unicode_h__

#ifdef __cplusplus
extern "C" {
#endif

/* uDirection's must be in this order */
enum uDirection { dNONE = 0, dRIGHT, dLEFT };
#ifndef __cplusplus
typedef enum uDirection uDirection;
#endif

/* blanks the background */
void drawUnicode(Display *display, Drawable drawable, GC gc,
				 int x,int y, const iUCode *string, int length);

/* doesn't blank the background */
void drawUnicodeText(Display *display, Drawable drawable, GC gc,
					 int x,int y, const iUCode *string, int length);

/* draws a single character */
void drawUnicodeChar(Display *display, Drawable drawable, GC gc,
					 int x,int y, const iUCode uni_char);

int unicodeDrawableP(Display *display, const iUCode *s);
void measureUnicode(Display *display, const iUCode *s, int l, int *tw, int *th, int *ascent);
void measureUnicodePos(Display *display, const iUCode *s, int l, int *tw, int *th, int *ascent);
XmString makeCompoundString(Display *display,const iUCode *string, int length, XmFontList *list);


/* handles context for unicode characters */
int uniSpacing(iUCode character);
uDirection uniOrder(const iUCode glyph);
#ifdef __cplusplus
};

// these functions only available for c++ routines
uString uniContext(const uString &line);
iUCode *uniDirection(iUCode *contextual, iUCode **ip = NULL);
#endif


#endif

