
#ifndef _RootElement_h_
#define _RootElement_h_


#include "ConstrainedRectangle.h"

class RootElement 
	: public ConstrainedRectangle
{
	DeletedPoolManager *deleted_element_manager;
	RTECursor *root_cursor;
	RTESelectionManager *root_selection_manager;
	TraversalManager *root_traversal_manager;
	InputEventHandler *input_handler;      // passed in to initializer
	VirtualDisplayDevice *display_device;  // passed in to initializer
protected:
	void getRootOffset(Coord *dx, Coord *dy) { *dx += x; *dy += y; };
public:

  /*virtual*/ int changeSizeTo(Coord, Coord, int redraw=TRUE);

	RootElement(InputEventHandler *, VirtualDisplayDevice *,
				Coord, Coord, Coord, Coord,
				Direction, Direction, Coord,
				int, int, int, int, int);

	~RootElement();
	DeletedPoolManager *getDeletedElementManager() { return deleted_element_manager; };
	RTECursor *getCursor() { return root_cursor; };
	RTESelectionManager * getSelectionManager() { return root_selection_manager; };
	int positionIsValid() { return position_valid == TRUE; };
	TraversalManager * getTraversalManager() { return root_traversal_manager; };
	InputEventHandler * getInputEventHandler() { return input_handler; };
	VirtualDisplayDevice * getDisplayDevice() { return display_device; };
	void sendToDeleted(ChildRectangle *child) { /* to be completed */ };
	void getFromDeleted(ChildRectangle *child) { /* to be completed */ };
	RootElement * getRoot() { return this; };
	RectangleType getType() { return RootElementT; };
};

#endif
