/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
/*
 * $Id: uchar.h,v 1.4 1994/11/14 22:46:03 maverick Exp $
 */

/*
 * Copyright 1990, 1991 by OMRON Corporation, NTT Software Corporation,
 *                      and Nippon Telegraph and Telephone Corporation
 * Copyright 1991 by the Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of OMRON, NTT Software, NTT, and M.I.T.
 * not be used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission. OMRON, NTT Software,
 * NTT, and M.I.T. make no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 *
 * OMRON, NTT SOFTWARE, NTT, AND M.I.T. DISCLAIM ALL WARRANTIES WITH REGARD
 * TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL OMRON, NTT SOFTWARE, NTT, OR M.I.T. BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 *	Author: Li Yuhong	OMRON Corporation
 *   
 */

#ifndef	_UCHAR_H_
#define _UCHAR_H_

#include "c-type.h"
#include <sys/types.h>
#include <stdio.h>
#ifdef __cplusplus
extern "C" {
#endif 
	
#ifndef WNULL
	
#if 0
	typedef __wchar_t uChar;
#else
	typedef unsigned short uChar;
#endif
	
#define WNULL	0
#define WEOF	0xffff
#endif
	
/*
 * DIS 10646 definition, but not reasonable in program I think.
 #define WNULL	0x00808080
 */
	
#ifndef MB_LEN_MAX
#define MB_LEN_MAX 6
#endif
	
/***********************/
/* Copy from "mit/lib/X/Xsi/uCharint.h" */
#ifndef	SCRIPT1
#define SCRIPT1		0xff00
#define CONTROLSCRIPT	0x00ff
#if 0
#define LATINSCRIPT	0x20202000
#else
#define LATINSCRIPT     0x0000
#endif
	
#if 0
#define HIRAGANASCRIPT	0x20202f00
#define KATAKANASCRIPT	0x20202f80
#define HANZISCRIPT	0x20308080
#define KANJISCRIPT	0x20408080
#define HANJASCRIPT	0x20508080
#else
#define HIRAGANASCRIPT	0x3040
#define KATAKANASCRIPT	0x30A0
#define HANZISCRIPT	0x4000
#define KANJISCRIPT	0x4000
#define HANJASCRIPT	0x4000
#endif
	
#if 0
#define CLPADPADPAD	0x00808080
#else
#define CLPADPADPAD	0x0000
#endif
	
#if 0
#define PrivateZone	0x20203400	/* Private Use Zone */
#define PrivateZoneLast 0x20203b00	/* Last row of Private Use Zone */
#define PrivatePlane	0x20e00000	/* Private Use Plane */
#define PrivatePlaneLast 0x20ff0000	/* Last row of Private Use Plane */
#define PrivatePlaneLastI11 (PrivatePlaneLast | 0x8080)
#define PrivatePlaneLastI10 (PrivatePlaneLast | 0x8000)
#endif
	
#define	wgetgroup(wc)	((unsigned char)(((wc) >> 8) & 0x00ff))
#define	wgetcell(wc)	((unsigned char)((wc) & 0x00ff))
#endif
/***********************/
/*
 * macro version of uChar functions
 *	Macros here evaluate their argument more than once
 *	Please take care to use these macros.
 *
 * COMMENT:  DEL is 0x7f
 *
 *	List of macros:	_iswalnum(), _iswalpha(), _iswdigit(),
 *			_iswlower(), _iswpunct(), _iswupper(),
 *			_iswxdigit(),
 *			_iswcntrl(), _iswspace(),
 *			_towupper(), _towupper(),
 *			_atowc(), _wctoa()
 *			_iswlatin1()
 *	Function only:	iswascii(), iswblank(), iswgraph(), iswprint()
 */
#if !defined(PC) /*&& !defined(SYS_PR)*/ /*macros*/
#define	_iswalnum(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && isalnum(wgetcell(wc)) )
#define	_iswalpha(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && isalpha(wgetcell(wc)) )
#define	_iswdigit(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && isdigit(wgetcell(wc)) )
#define	_iswlower(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && islower(wgetcell(wc)) )
#define	_iswpunct(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && ispunct(wgetcell(wc)) )
#define	_iswupper(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && isupper(wgetcell(wc)) )
#define	_iswxdigit(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT	\
&& isascii(wgetcell(wc)) && isxdigit(wgetcell(wc)) )
#define	_iswlatin1(wc)	( ((wc)&SCRIPT1)==LATINSCRIPT || _iswcntrl(wc) )
	
	
#if 0
#define	_iswcntrl(wc)	( ((wc)==WNULL) || (((wc)&CONTROLSCRIPT)==CLPADPADPAD \
&& iscntrl(wgetgroup(wc)&0x7f)) )
#else
#define _iswcntrl(wc)  (0)
#endif
	
#if 0
#define	_iswspace(wc)	( (((wc)&CONTROLSCRIPT)==CLPADPADPAD) ?	\
(isspace(wgetgroup(wc))) :		\
(_iswblank(wc)) )
#else
#define _iswspace(wc) (0)
#endif
#define	_iswascii(wc)	iswascii(wc)
#define	_iswblank(wc)	iswblank(wc)
#define	_iswgraph(wc)	iswgraph(wc)
#if 0
#define	_iswprint(wc)	iswprint(wc)
#endif
	
#define	_towlower(wc)	( (_iswupper(wc))?			\
	(LATINSCRIPT|(tolower(wgetcell(wc)))):	\
	(wc) )
#define	_towupper(wc)	( (_iswlower(wc))?			\
	(LATINSCRIPT|(toupper(wgetcell(wc)))):	\
	(wc) )
#endif /*macros*/
	
#if 0
#define	_atowc(c)	( ((c)=='\0') ? WNULL:				\
	(iscntrl((c)&0x7f)) ? (((c)<<24)|CLPADPADPAD):	\
	(LATINSCRIPT|(c)) )
#else
#define	_atowc(c)	( ((c)=='\0') ? WNULL:				\
	(LATINSCRIPT|(c)))
#endif
	
#if 0
#define	_wctoa(wc)	( _iswcntrl(wc) ? wgetgroup(wc):		\
	(((wc)&SCRIPT1)==LATINSCRIPT) ? wgetcell(wc):	\
	(-1) )
#else
#define	_wctoa(wc)	 ( (((wc)&SCRIPT1)==LATINSCRIPT) ? wgetcell(wc):	\
	(-1) )
#endif
	
	
/*
 * Function declarations
 */
#if !defined(PC) && !defined(SYS_PR)
	extern int	iswalnum(uChar);
	extern int	iswalpha(uChar);
	extern int	iswascii(uChar);	/* not in MSE */
	extern int	iswblank(uChar);	/* not in MSE */
	extern int	iswcntrl(uChar);
	extern int	iswdigit(uChar);
	extern int	iswlatin1(uChar);	/* not in MSE */
	extern int	iswlower(uChar);
#if 0
	extern int	iswgraph(uChar);
	extern int	iswprint(uChar);
	extern int	wcswidth(const uChar*, size_t);
	extern int	wcwidth(const uChar);
#endif
	extern int	iswspace(uChar);
	extern int	iswupper(uChar);
	extern int	iswxdigit(uChar);
	extern uChar	towlower(uChar);
	extern uChar	towupper(uChar);
#endif
	
/* 
 * functions similar to char string manupulation.
 */
#ifndef SYS_PR
	extern uChar	atowc(const unsigned char);	/* not in MSE */
	extern char	wctoa(const uChar);		/* not in MSE */
	extern char	*wstos(char*, const uChar*);	/* not in MSE */
	extern uChar 	*wcscpy(uChar*, const uChar*);
	extern uChar 	*wcsncpy(uChar*, const uChar*, size_t);
	extern uChar 	*wcscat(uChar*, const uChar*);
	extern uChar 	*wcsncat(uChar*, const uChar*, size_t);
	extern uChar 	*wcsdup(uChar *);
	extern int	wcscmp(const uChar*, const uChar*);
	extern int	wcsncmp(const uChar*, const uChar*, size_t);
	extern const uChar 	*wcschr(const uChar*, const int);
	extern const uChar 	*wcsrchr(const uChar*, const uChar);
	extern size_t	wcslen(const uChar*);
	extern void	wcsreverse(uChar*);		/* not in MSE */
	
/* added by mav as other implementation was brain-dead */
	extern uChar *stows(uChar *, char *s);
	extern uChar *strtowcs(uChar *, char *s);
	
	extern unsigned long wcsspn(uChar *, uChar *);
	extern unsigned long wcscspn(uChar *, uChar *);
	
	extern uChar *wcspbrk(uChar *, uChar *);
	extern uChar *wcswcs(uChar *, uChar *);
	extern char *wcstostr(uChar *,char *);
#endif
#ifdef __cplusplus
	};
#endif
	
	
#endif /* _UCHAR_H_ */
