
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
// This is a main for a debugging application that uses the keyboard
// I dont know that it still works
*/
#include "rafport.h"
#include "str-lib.h"

#include <Xm/Xm.h>

#include "KeyBoard.h"
#include "KeyMap.h"

XtAppContext global_app_context; 

extern KeyMap *initAmerican();
extern KeyMap *initRussian();
extern KeyMap *initEnglish();
extern KeyMap *initFrench();
extern KeyMap *initGerman();
extern KeyMap *initGreek();
extern KeyMap *initMicr();
extern KeyMap *initSwedish();


void
keyboardH(void *user_data, KeySym sym, iUCode result)
{
	
	printf("keyboard widget hit, value=0x%x  ",result);
	if (result<128 && result>=32) printf("'%c'",result);
	printf("\n");
}

void pressKeyEH(Widget w, KeyBoard *kb, XEvent *event)
{
	char key_value;
	unsigned short trans_key;
	int n;
	KeySym ks;
	
	n = XLookupString(&event->xkey,&key_value,1,&ks,0);
	printf("key pressed, value=0x%x  ",key_value);
	if (key_value>=32) printf("'%c'",key_value);
	trans_key = kb->key_map->lookupValue(ks);
	printf("  translated value=0x%x  ",key_value);
	if (trans_key<128 && trans_key>=32) printf("'%c'",trans_key);
	printf("\n");
	
}

int
main(int argc, char **argv)
{
	Widget app_shell;
	ArgList args;
	KeyBoard *kb;
	KeyMap *american = initAmerican();
	KeyMap *russian = initRussian();
	KeyMap *english = initEnglish();
	KeyMap *german = initGerman();
	KeyMap *french = initFrench();
	KeyMap *greek = initGreek();
	KeyMap *micr = initMicr();
	KeyMap *swedish = initSwedish();
	
	XmFontListEntry entry;
	XmFontList font_list;
	
	app_shell = XtAppInitialize(&global_app_context, 
								"KeyBoard", NULL, 0, &argc,
								argv, NULL, args, 0);
	
	entry = XmFontListEntryLoad(XtDisplay(app_shell),
								"-etl-fixed-medium-r-normal--16-120-100-100-c-80-iso8859-5",
								XmFONT_IS_FONT,
								"cyrillic");
	font_list = XmFontListAppendEntry(NULL, entry);
	kb = new KeyBoard(app_shell, russian,keyboardH,0);
	
//   XtRealizeWidget (app_shell);
	miscInit(app_shell);
	XtAddEventHandler(kb->bb, KeyPressMask, FALSE, 
					  (XtEventHandler) pressKeyEH, kb); 
	kb->show();
	
	XtAppMainLoop (global_app_context);
	
	return 0;
}

