/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
#include "rafport.h"
#include "str-lib.h"

#include <X11/keysym.h>

#include "KeyMap.h"

KeyMap *
initMicr()
{
    KeyMap *micr;
    KeyMap *keymap;
	
    micr = new KeyMap("MICR");
    keymap = micr;
	
	
    keymap->setTable(XK_c, uString(0x2446), 0x2446, uString(0x2446));
    keymap->setTable(XK_i, uString(0x2447), 0x2447, uString(0x2447));
    keymap->setTable(XK_r, uString(0x2448), 0x2448, uString(0x2448));
    keymap->setTable(XK_m, uString(0x2449), 0x2449, uString(0x2449));
    keymap->setTable(XK_1, uString('1'), '1', uString('1'));
    keymap->setTable(XK_2, uString('2'), '2', uString('2'));
    keymap->setTable(XK_3, uString('3'), '3', uString('3'));
    keymap->setTable(XK_4, uString('4'), '4', uString('4'));
    keymap->setTable(XK_5, uString('5'), '5', uString('5'));
    keymap->setTable(XK_6, uString('6'), '6', uString('6'));
    keymap->setTable(XK_7, uString('7'), '7', uString('7'));
    keymap->setTable(XK_8, uString('8'), '8', uString('8'));
    keymap->setTable(XK_9, uString('9'), '9', uString('9'));
    keymap->setTable(XK_0, uString('0'), '0', uString('0'));
    keymap->setTable(XK_space, uString(), ' ', uString(' '));
    keymap->setTable(XK_Delete, uString("Del"), '\b', uString());
    keymap->setTable(XK_Escape, uString(), '\0', uString());
    keymap->setTable(XK_BackSpace, uString("BS"), '\b', uString());
    keymap->setTable(XK_Tab, uString("Tab"), '\t', uString('\t'));
    keymap->setTable(XK_Shift_L, uString("Shift"), '\0', uString());
    keymap->setTable(XK_Shift_R, uString("Shift"), '\0', uString());
    keymap->setTable(XK_Alt_L, uString("Alt"), '\0', uString());
    keymap->setTable(XK_Meta_L, uString("Meta"), '\0', uString());
    keymap->setTable(XK_Meta_R, uString("Meta"), '\0', uString());
    keymap->setTable(XK_Alt_R, uString(), '\0', uString());
    keymap->setTable(XK_Super_R, uString(), '\0', uString());
    keymap->setTable(XK_Control_R, uString(), '\0', uString("xo"));
    keymap->setTable(XK_Caps_Lock, uString(), '\0', uString());
    keymap->setTable(XK_Control_L, uString("Control"), '\0', uString());
    keymap->setTable(XK_Return, uString("Ret"), '\n', uString('\n'));

    return keymap;
}

