
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
#include "rafport.h"
#include "str-lib.h"


#include <X11/keysym.h>

#include "KeyMap.h"

KeyMap *
initRussian()
{
	KeyMap *russian;
	KeyMap *keymap;
	
	russian = new KeyMap("Russian");
	keymap = russian;
	
	keymap->setTable(XK_backslash, uString(), '\\', uString());
	keymap->setTable(XK_Delete, uString("Del"), '\b', uString());
	
	keymap->setTable(XK_Escape, uString(), '\0', uString());
	keymap->setTable(XK_1, uString('1'), '1', uString('1'));
	keymap->setTable(XK_2, uString('2'), '2', uString('2'));
	keymap->setTable(XK_3, uString('3'), '3', uString('3'));
	keymap->setTable(XK_4, uString('4'), '4', uString('4'));
	keymap->setTable(XK_5, uString('5'), '5', uString('5'));
	keymap->setTable(XK_6, uString('6'), '6', uString('6'));
	keymap->setTable(XK_7, uString('7'), '7', uString('7'));
	keymap->setTable(XK_8, uString('8'), '8', uString('8'));
	keymap->setTable(XK_9, uString('9'), '9', uString('9'));
	keymap->setTable(XK_0, uString('0'), '0', uString('0'));
	keymap->setTable(XK_minus, uString('='), '=', uString('='));
	keymap->setTable(XK_equal, uString('\''), '\'', uString('\''));
	keymap->setTable(XK_BackSpace, uString("BS"), '\b', uString());
	
	keymap->setTable(XK_Tab, uString("Tab"), '\t', uString('\t'));
	keymap->setTable(XK_q, uString(0x0439), 0x0439, uString(0x0439)); 
	keymap->setTable(XK_w, uString(0x0446), 0x0446, uString(0x0446)); 
	keymap->setTable(XK_e, uString(0x0443), 0x0443, uString(0x0443)); 
	keymap->setTable(XK_r, uString(0x043a), 0x043a, uString(0x043a)); 
	keymap->setTable(XK_t, uString(0x0435), 0x0435, uString(0x0435)); 
	keymap->setTable(XK_y, uString(0x043d), 0x043d, uString(0x043d)); 
	keymap->setTable(XK_u, uString(0x0433), 0x0433, uString(0x0433)); 
	keymap->setTable(XK_i, uString(0x0448), 0x0448, uString(0x0448)); 
	keymap->setTable(XK_o, uString(0x0449), 0x0449, uString(0x0449)); 
	keymap->setTable(XK_p, uString(0x044d), 0x044d, uString(0x044d)); 
	keymap->setTable(XK_bracketleft, uString(0x0445), 0x0445, uString(0x0445)); 
	keymap->setTable(XK_bracketright, uString(0x044a), 0x044a, uString(0x044a)); 
	keymap->setTable(XK_Return, uString("Ret"), '\n', uString('\n'));
	
	keymap->setTable(XK_Control_L, uString("Control"), '\0', uString());
	keymap->setTable(XK_a, uString(0x0444), 0x0444, uString(0x0444)); 
	keymap->setTable(XK_s, uString(0x044b), 0x044b, uString(0x044b)); 
	keymap->setTable(XK_d, uString(0x0432), 0x0432, uString(0x0432)); 
	keymap->setTable(XK_f, uString(0x0430), 0x0430, uString(0x0430)); 
	keymap->setTable(XK_g, uString(0x043f), 0x043f, uString(0x043f)); 
	keymap->setTable(XK_h, uString(0x0440), 0x0440, uString(0x0440)); 
	keymap->setTable(XK_j, uString(0x043e), 0x043e, uString(0x043e)); 
	keymap->setTable(XK_k, uString(0x043b), 0x043b, uString(0x043b)); 
	keymap->setTable(XK_l, uString(0x0434), 0x0434, uString(0x0434)); 
	keymap->setTable(XK_semicolon, uString(0x0436), 0x0436, uString(0x0436)); 
	keymap->setTable(XK_quoteright, uString(0x044d), 0x044d, uString(0x044d)); 
	keymap->setTable(XK_quoteleft, uString(), '\0', uString());
	
	keymap->setTable(XK_Shift_L, uString("Shift"), '\0', uString());
	keymap->setTable(XK_z, uString(0x044f), 0x044f, uString(0x044f)); 
	keymap->setTable(XK_x, uString(0x0447), 0x0447, uString(0x0447)); 
	keymap->setTable(XK_c, uString(0x0441), 0x0441, uString(0x0441)); 
	keymap->setTable(XK_v, uString(0x043c), 0x043c, uString(0x043c)); 
	keymap->setTable(XK_b, uString(0x0438), 0x0438, uString(0x0438)); 
	keymap->setTable(XK_n, uString(0x0442), 0x0442, uString(0x0442)); 
	keymap->setTable(XK_m, uString(0x044c), 0x044c, uString(0x044c)); 
	keymap->setTable(XK_less, uString(0x0411), 0x0411, uString(0x0411)); 
	keymap->setTable(XK_greater, uString(0x042e), 0x042e, uString(0x042e));
	keymap->setTable(XK_question, uString(0x0401), 0x0401, uString(0x0401));
	keymap->setTable(XK_Shift_R, uString("Shift"), '\0', uString());
	keymap->setTable(XK_Linefeed, uString("LF"), '\0', uString());
	
	keymap->setTable(XK_Caps_Lock, uString(), '\0', uString());
	keymap->setTable(XK_Alt_L, uString("Alt"), '\0', uString());
	keymap->setTable(XK_Meta_L, uString("Meta"), '\0', uString());
	keymap->setTable(XK_space, uString(), ' ', uString(' '));
	keymap->setTable(XK_Meta_R, uString("Meta"), '\0', uString());
	keymap->setTable(XK_Alt_R, uString(), '\0', uString());
	keymap->setTable(XK_Super_R, uString(), '\0', uString());
	
	keymap->setTable(XK_Control_R, uString(), '\0', uString());
	
	keymap->setTable(XK_bar, uString('|'), '|', uString('|'));
	
	keymap->setTable(XK_exclam, uString(0x2116), 0x2116, uString(0x2116)); 
	
	keymap->setTable(XK_at, uString('-'), '-', uString('-'));
	
	keymap->setTable(XK_numbersign, uString('/'), '/', uString('/'));
	
	keymap->setTable(XK_dollar, uString('\"'), '\"', uString('\"'));
	keymap->setTable(XK_percent, uString(':'), ':', uString(':'));
	keymap->setTable(XK_asciicircum, uString(','), ',', uString(','));
	keymap->setTable(XK_ampersand, uString('.'), '.', uString('.'));
	
	keymap->setTable(XK_asterisk, uString('_'), '_', uString('_'));
	keymap->setTable(XK_parenleft, uString('?'), '?', uString('?'));
	keymap->setTable(XK_parenright, uString('%'), '%', uString('%'));
	keymap->setTable(XK_underscore, uString('!'), '!', uString('!'));
	keymap->setTable(XK_plus, uString('+'), '+', uString('+'));
	
	keymap->setTable(XK_Q, uString(0x0419), 0x0419, uString(0x0419)); 
	keymap->setTable(XK_W, uString(0x0426), 0x0426, uString(0x0426)); 
	keymap->setTable(XK_E, uString(0x0423), 0x0423, uString(0x0423)); 
	keymap->setTable(XK_R, uString(0x041a), 0x041a, uString(0x041a)); 
	keymap->setTable(XK_T, uString(0x0415), 0x0415, uString(0x0415)); 
	keymap->setTable(XK_Y, uString(0x041d), 0x041d, uString(0x041d)); 
	keymap->setTable(XK_U, uString(0x0413), 0x0413, uString(0x0413)); 
	keymap->setTable(XK_I, uString(0x0428), 0x0428, uString(0x0428)); 
	keymap->setTable(XK_O, uString(0x0429), 0x0429, uString(0x0429)); 
	keymap->setTable(XK_P, uString(0x0417), 0x0417, uString(0x0417)); 
	keymap->setTable(XK_braceleft , uString(0x0425), 0x0425, uString(0x0425));
	keymap->setTable(XK_braceright, uString(0x042a), 0x042a, uString(0x042a)); 
	
	keymap->setTable(XK_A, uString(0x0424), 0x0424, uString(0x0424)); 
	keymap->setTable(XK_S, uString(0x042b), 0x042b, uString(0x042b));
	keymap->setTable(XK_D, uString(0x0412), 0x0412, uString(0x0412));
	keymap->setTable(XK_F, uString(0x0410), 0x0410, uString(0x0410));
	keymap->setTable(XK_G, uString(0x041f), 0x041f, uString(0x041f));
	keymap->setTable(XK_H, uString(0x0420), 0x0420, uString(0x0420));
	keymap->setTable(XK_J, uString(0x041e), 0x041e, uString(0x041e));
	keymap->setTable(XK_K, uString(0x041b), 0x041b, uString(0x041b));
	keymap->setTable(XK_L, uString(0x0414), 0x0414, uString(0x0414));
	keymap->setTable(XK_colon, uString(0x0416), 0x0416, uString(0x0416));
	keymap->setTable(XK_quotedbl, uString(0x042d), 0x042d, uString(0x042d));
	keymap->setTable(XK_asciitilde, uString('~'), '~', uString('~'));
	
	keymap->setTable(XK_Z, uString(0x042f), 0x042f, uString(0x042f));
	keymap->setTable(XK_X, uString(0x0427), 0x0427, uString(0x0427));
	keymap->setTable(XK_C, uString(0x0421), 0x0421, uString(0x0421));
	keymap->setTable(XK_V, uString(0x041c), 0x041c, uString(0x041c));
	keymap->setTable(XK_B, uString(0x0418), 0x0418, uString(0x0418));
	keymap->setTable(XK_N, uString(0x0422), 0x0422, uString(0x0422));
	keymap->setTable(XK_M, uString(0x042c), 0x042c, uString(0x042c));
	keymap->setTable(XK_comma, uString(0x0431), 0x0431, uString(0x0431));
	keymap->setTable(XK_period, uString(0x044e), 0x044e, uString(0x044e)); 
	keymap->setTable(XK_slash, uString(0x0451), 0x0451, uString(0x0451)); 
	
	/*
// control chars
*/
	
	keymap->setControlTable(XK_backslash, uString(0x2015),0x2015,uString(0x2015));
	keymap->setControlTable(XK_Delete, uString("Del"), '\b', uString());
    
	keymap->setControlTable(XK_Escape, uString(), '\0', uString());
	keymap->setControlTable(XK_1, uString(0x0457), 0x0457, uString(0x0457));
	keymap->setControlTable(XK_2, uString('&'), '&', uString('&'));
	keymap->setControlTable(XK_3, uString(0x00ab), 0x00ab, uString(0x00ab));
	keymap->setControlTable(XK_4, uString(0x00bb), 0x00bb, uString(0x00bb));
	keymap->setControlTable(XK_5, uString(0x2030), 0x2030, uString(0x2030));
	keymap->setControlTable(XK_6, uString(0x2020), 0x2020, uString(0x2020));
	keymap->setControlTable(XK_7,  uString(0x2021), 0x2021, uString(0x2021));
	keymap->setControlTable(XK_8, uString(0x007b), 0x007b, uString(0x007b));
	keymap->setControlTable(XK_9, uString(0x005b), 0x005b, uString(0x005b));
	keymap->setControlTable(XK_0, uString(0x005d), 0x005d, uString(0x005d));
	keymap->setControlTable(XK_minus, uString(0x007d), 0x007d, uString(0x007d));
	keymap->setControlTable(XK_equal, uString(0x00b6), 0x00b6, uString(0x00b6));
	keymap->setControlTable(XK_BackSpace, uString("BS"), '\0', uString());
    
	keymap->setControlTable(XK_Tab, uString("Tab"), '\t', uString('\t'));
	keymap->setControlTable(XK_q, uString(0x00ac), 0x00ac, uString(0x00ac)); 
	keymap->setControlTable(XK_w, uString(0x2026), 0x2026, uString(0x2026));
	keymap->setControlTable(XK_e, uString(0x045e), 0x045e, uString(0x045e)); 
	keymap->setControlTable(XK_r, uString(0x00a6), 0x00a6, uString(0x00a6)); 
	keymap->setControlTable(XK_t, uString(0x00a7), 0x00a7, uString(0x00a7)); 
	keymap->setControlTable(XK_y, uString(0x0023), 0x0023, uString(0x0023)); 
	keymap->setControlTable(XK_u, uString(0x00b0), 0x00b0, uString(0x00b0)); 
	keymap->setControlTable(XK_i, uString(0x00b1), 0x00b1, uString(0x00b1));
	keymap->setControlTable(XK_o, uString(0x0024), 0x0024, uString(0x0024)); 
	keymap->setControlTable(XK_p, uString(), '\0', uString());
	keymap->setControlTable(XK_bracketleft, uString(0x002a), 0x002a, uString(0x002a)); 
	keymap->setControlTable(XK_bracketright, uString(0x00ad), 0x00ad, uString(0x00ad)); 
	keymap->setControlTable(XK_Return, uString("Ret"), '\n', uString('\n'));
	
	keymap->setControlTable(XK_Control_L, uString("Control"), '\0', uString());
	keymap->setControlTable(XK_a, uString(0x007e), 0x007e, uString(0x007e)); 
	keymap->setControlTable(XK_s, uString(0x005e), 0x005e, uString(0x005e)); 
	keymap->setControlTable(XK_d, uString(';'), ';', uString(';')); 
	keymap->setControlTable(XK_f, uString(0x2022), 0x2022, uString(0x2022));
	keymap->setControlTable(XK_g, uString(0x00b7), 0x00b7, uString(0x00b7)); 
	keymap->setControlTable(XK_h,  uString(0x201a), 0x201a, uString(0x201a));
	
	keymap->setControlTable(XK_j, uString(0x201e), 0x201e, uString(0x201e)); 
	keymap->setControlTable(XK_k,  uString(0x2019), 0x2019, uString(0x2019));
	keymap->setControlTable(XK_l,  uString(0x201c), 0x201c, uString(0x201c));
	
	keymap->setControlTable(XK_semicolon, uString(0x201d), 0x201d, uString(0x201d));
	
	keymap->setControlTable(XK_quoteright,  uString(0x201d), 0x201d, uString(0x201d));
	
	keymap->setControlTable(XK_quoteleft, uString(), 0, uString()); 
	
	keymap->setControlTable(XK_Shift_L, uString("Shift"), '\0', uString());
	keymap->setControlTable(XK_z, uString(0x005c), 0x005c, uString(0x005c)); 
	keymap->setControlTable(XK_x, uString(0x007c), 0x007c, uString(0x007c)); 
	keymap->setControlTable(XK_c, uString(), '\0', uString());
	keymap->setControlTable(XK_v, uString(0x00b5), 0x00b5, uString(0x00b5)); 
	keymap->setControlTable(XK_b, uString(), '\0', uString());      
	keymap->setControlTable(XK_n, uString(), '\0', uString());                     
	keymap->setControlTable(XK_m, uString(), '\0', uString()); 
	                    
	keymap->setControlTable(XK_question, uString(), '\0', uString());       
	keymap->setControlTable(XK_Shift_R, uString("Shift"), '\0', uString());
	keymap->setControlTable(XK_Linefeed, uString("LF"), '\0', uString());
	
    
	keymap->setControlTable(XK_bar, uString(), '\0', uString());
    
	keymap->setControlTable(XK_exclam, uString(0x2116), 0x2116, uString(0x2116)); 
	keymap->setControlTable(XK_at, uString(), '\0', uString());
	keymap->setControlTable(XK_numbersign, uString(0x2039), 0x2039, uString(0x2039));
	keymap->setControlTable(XK_dollar, uString(0x203a), 0x203a, uString(0x203a));
	keymap->setControlTable(XK_percent, uString(), '\0', uString());
	keymap->setControlTable(XK_asciicircum, uString(), '\0', uString());
	keymap->setControlTable(XK_ampersand, uString(), '\0', uString());
	keymap->setControlTable(XK_asterisk, uString(0x003c), 0x003c, uString(0x003c));
	keymap->setControlTable(XK_parenleft, uString(0x0028), 0x0028, uString(0x0028));
	keymap->setControlTable(XK_parenright, uString(0x0029), 0x0029, uString(0x0029));
	keymap->setControlTable(XK_underscore, uString(0x003e), 0x003e, uString(0x003e));
	keymap->setControlTable(XK_plus, uString(), '\0', uString());
    
	keymap->setControlTable(XK_Q, uString(), '\0', uString());
	keymap->setControlTable(XK_W, uString(), '\0', uString());
	keymap->setControlTable(XK_E, uString(0x040e), 0x040e, uString(0x040e));
	keymap->setControlTable(XK_R, uString(), '\0', uString()); 
	keymap->setControlTable(XK_T, uString(), '\0', uString());
	keymap->setControlTable(XK_Y, uString(), '\0', uString()); 
	keymap->setControlTable(XK_U, uString(), '\0', uString());
	keymap->setControlTable(XK_I, uString(), '\0', uString());
	keymap->setControlTable(XK_O, uString(0x2121), 0x2121, uString(0x2121));
	keymap->setControlTable(XK_P, uString(0x00d7), 0x00d7, uString(0x00d7));
	keymap->setControlTable(XK_braceleft, uString(0x00f7), 0x00f7, uString(0x00f7));
	keymap->setControlTable(XK_braceright, uString(0x00b1), 0x00b1, uString(0x00b1));
    
	keymap->setControlTable(XK_A, uString(), '\0', uString());
	keymap->setControlTable(XK_S, uString(), '\0', uString());
	keymap->setControlTable(XK_D, uString(), '\0', uString());
	keymap->setControlTable(XK_F, uString(), '\0', uString());
	keymap->setControlTable(XK_G, uString(), '\0', uString());
	keymap->setControlTable(XK_H, uString(), '\0', uString());
	keymap->setControlTable(XK_J, uString(), '\0', uString());
	keymap->setControlTable(XK_K, uString(), '\0', uString());
	keymap->setControlTable(XK_L, uString(), '\0', uString());
	keymap->setControlTable(XK_colon, uString(), '\0', uString());
	keymap->setControlTable(XK_quotedbl, uString(), '\0', uString());
	keymap->setControlTable(XK_asciitilde, uString(), '\0', uString());
    
	keymap->setControlTable(XK_Z, uString(), '\0', uString());
	keymap->setControlTable(XK_X, uString(), '\0', uString());
	keymap->setControlTable(XK_C, uString(), '\0', uString());
	keymap->setControlTable(XK_V, uString(), '\0', uString());
	keymap->setControlTable(XK_B, uString(), '\0', uString());
	keymap->setControlTable(XK_N, uString(), '\0', uString());
	keymap->setControlTable(XK_M, uString(), '\0', uString());
	keymap->setControlTable(XK_less, uString(0x00ab),0x00ab, uString(0x00ab));	
	keymap->setControlTable(XK_greater, uString(0x00bb),0x00bb, uString(0x00bb));	
	keymap->setControlTable(XK_comma, uString(0x2039),0x2039, uString(0x2039));	
	keymap->setControlTable(XK_period, uString(0x203a),0x203a, uString(0x203a));	
	keymap->setControlTable(XK_slash, uString(), '\0', uString());
	
	return keymap;
}

