
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include <stdlib.h>

#include "color.h"
#include "svpmap.h"

#include "misc.h"

static Widget global_toplevel = 0;
stringVoidPtrMap *color_name_map = 0;
int color_depth = 1;

void
miscInit(Widget toplevel)
{
	global_toplevel = toplevel;
	
	
	if(toplevel){
		Display *display  = XtDisplay(toplevel);
		int      screen  = DefaultScreen(display);
		
		color_name_map = svmapAlloc();
	
		color_depth = DefaultDepthOfScreen(XtScreen(toplevel));

		svmapInit(color_name_map, (void *) BlackPixel(display, screen), 256);
	}
}

void
miscExit()
{
	if(color_name_map){
		svmapCleanup(color_name_map);
		svmapFree(color_name_map);
		color_name_map = 0;
	}
}
