#############################################################
#
# This makefile copyright 1993 RAF Technology
# All rights reserved
#
# Author: Thomas M. J. Fruchterman
#
#############################################################
#
# included at the bottom of makefiles
#
# have to be similar to makefile.proto
#
SOURCES=${MODULES:%=%.c}
OBJECTS=${MODULES:%=${OBJ_DIR}/%.o}
REAL_LIB_HEADERS=${LIB_HEADERS:%=${LOCAL_INCLUDE_DIR}${SUBDIR}/%}

# turn this on to turn on dependencies for all libs
#DEPENDS=${MODULES:%=%.d}
#include ${DEPENDS}

${LIB_TARGET}: ${OBJECTS}
	\rm -f $@
	${AR} $@ ${OBJECTS}
	${RANLIB} $@

${MOD_TARGET}: ${OBJECTS}
	ld -o $@ -r -x ${OBJECTS}

${APP_TARGET}: ${OBJECTS}
	${CC} ${CFLAGS} ${LOAD_FLAGS} ${LIB_PATH} ${OBJECTS} -o $@ ${LIBS}
	
${APP_STATIC}: ${OBJECTS}
	${CC} ${CFLAGS} ${LOAD_FLAGS} ${LIB_PATH} ${OBJECTS} -static -o $@ ${LIBS} 

TEST_OBJECTS=${TEST_MODULES:%=${OBJ_DIR}/%.o}
${TEST_TARGET}: ${OBJECTS} ${TEST_OBJECTS}
	${CC} ${CFLAGS} ${LOAD_FLAGS} ${LIB_PATH} ${OBJECTS} ${TEST_OBJECTS} -o $@ ${LIBS}

install-mod: ${LOCAL_LIB_DIR}/${OBJ_DIR}/mod${LIB_NAME}.o

uninstall:
	-\rm ${LOCAL_LIB_DIR}/${OBJ_DIR}/lib${LIB_NAME}.a
	-\rm ${LOCAL_BIN_DIR}/${APP_NAME}
	-\rm ${REAL_LIB_HEADERS}
	

install-lib: ${LOCAL_LIB_DIR}/${OBJ_DIR}/lib${LIB_NAME}.a install-headers 

install-headers: ${REAL_LIB_HEADERS}

#	test "${LIB_HEADERS}" = "" || for i in ${LIB_HEADERS} ; do rm -f ${LOCAL_INCLUDE_DIR}${SUBDIR}/$${i}; cp $${i} ${LOCAL_INCLUDE_DIR}${SUBDIR} ; chmod g+w  ${LOCAL_INCLUDE_DIR}${SUBDIR}/$${i}; done

install-app: ${APP_TARGET}
	cp ${APP_TARGET} ${LOCAL_BIN_DIR}

install-static: ${APP_STATIC}
	cp ${APP_STATIC} ${LOCAL_BIN_DIR}

install-apps: ${APP_TARGETS}
	cp ${APP_TARGETS} ${LOCAL_BIN_DIR}

	
${BIN_DIR}:
	mkdir $@

${LOCAL_DIR}/bin:
	mkdir $@

${LOCAL_BIN_DIR}: ${LOCAL_DIR}/bin
	mkdir $@

${LOCAL_LIB_DIR}:
	mkdir $@

${LOCAL_INCLUDE_DIR}${SUBDIR}:
	-mkdir ${LOCAL_INCLUDE_DIR}
	-mkdir $@

${LOCAL_LIB_DIR}/${OBJ_DIR}:
	mkdir $@

FORCE:

app: ${LIB_TARGET}

lib: ${APP_TARGET}

rm-target:
	-\rm ${APP_TARGET}

relink: rm-target ${APP_TARGET}

clean: FORCE
	rm -f ${OBJ_DIR}/*

info:
	-rcschanged

update:
	rcsupdate

alarm:
	alarm

