
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "rafport.h"

#include "c-type.h"
#include "str-lib.h"
#include "io-lib.h"
#include "rafutil.h"

void
splitPathAndName(char *path_and_file,
				 char path[],
				 char file[])
{
	int len = strlen(path_and_file);
	int last_slash_index;
	const char separator = DIRECTORY_SLASH;
	
	for(last_slash_index = len - 1; last_slash_index >= 0; last_slash_index--)
		if(path_and_file[last_slash_index] == separator)
			break;
	if(last_slash_index < 0){
		strcpy(path, "");
		sprintf(file, "%s", path_and_file);
	} else {
		strncpy(path, path_and_file, last_slash_index + 1);
		path[last_slash_index + 1] = '\0';
		strcpy(file, &(path_and_file[last_slash_index + 1]));
	}
}

void
splitBaseAndSuffix(char *base_and_suffix,
				   char base[],
				   char suffix[])
{
	int len = strlen(base_and_suffix);
	int last_period_index;
	const char separator = '.';
	
	for(last_period_index = len-1; last_period_index >= 0; last_period_index--)
		if(base_and_suffix[last_period_index] == separator)
			break;
	if(last_period_index < 0){
		strcpy(suffix, "");
		strcpy(base, base_and_suffix);
	} else {
		strncpy(base, base_and_suffix, last_period_index + 1);
		base[last_period_index + 1] = '\0';
		strcpy(suffix, &(base_and_suffix[last_period_index + 1]));
	}
}
