
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _io_lib_h
#define _io_lib_h

#include "rafport.h"
#include <varargs.h>
#include "str-lib.h"

#include <stdio.h>

#ifdef SYS_OS_SUNOS

/* why and when was this changed? */
#if 0
#ifndef __cplusplus
#ifdef NULL
#undef NULL
#endif
#endif
#endif

#else /* SYS_OS_SUNOS */

#include <sys/types.h>
#if defined(__cplusplus) && defined(SYS_OS_DOS)
  EXTERN_C  int sprintf(char *s, const char *format, ...);
#endif

#endif

#if !defined(SYS_OS_SOLARIS) && !defined(SYS_OS_LINUX) && !defined(__cplusplus) && !defined(SYS_OS_MERC)
	EXTERN_C int fgetc(FILE *stream);
	EXTERN_C int vfprintf(FILE *, const char *format, va_list);
	EXTERN_C int fprintf(FILE *, const char *, ...);
	EXTERN_C int printf(const char *, ...);
	EXTERN_C int fscanf(FILE *stream, const char *format, ...);
	EXTERN_C int sscanf(const char *string, const char *format, ...);
	EXTERN_C size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
	EXTERN_C size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
	EXTERN_C int fflush(FILE *stream);
	
	EXTERN_C int fseek(FILE *stream, long offset, int ptrname);
	
	EXTERN_C int fclose(FILE *stream);
#endif

#if defined(SYS_OS_SUNOS)
#define tolower(c) ((c) - 'A' + 'a')
#endif


#endif /* _io_lib_h_ */

