/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "g3states.h"

/*
// global data
// This is obviously missing the original TIFF disclaimer
//
// it contains several large tables
// the question is, what can be done to make it more palatable to
// DOS
//
// answer -- first, we can declare it huge,
// where does the huge keyword go?
// second, it has a lot of double index arrays, they can be broken up
// into two levels of arrays
// unsigned char	RlNextState1D[230][256]
//
// 230 * 256 < 64k
// 
*/

 unsigned char	RlNextState1D[230][256] = {
/* prefix 0 */ {
     16, 17,  0,  0,  0,  0,  7,  7,  7,  7,  0,  0,  6,  6, /*   0- 13 */
      6,  6,  7,  7,  0,  0,  0,  0,  0,  0,  7,  7,  0,  0, /*  14- 27 */
      6,  6,  6,  6,  6,  6,  6,  6,  0,  0,  7,  7,  0,  0, /*  28- 41 */
      0,  0,  0,  0,  7,  7,  7,  7,  0,  0,  0,  0,  0,  0, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  7,  7,  0,  0, 18, 19,  7,  7,  7,  7,  0,  0, /*  70- 83 */
      0,  0,  7,  7,  0,  0,  0,  0,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  0,  0, 20,  0,  0, 21, 22, 23, 24, 25,  7,  7, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      6,  6,  6,  6,  6,  6,  6,  6,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  6,  6, /* 196-209 */
      6,  6,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 224-237 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 238-251 */
      4,  4,  4,  4
},
/* prefix 1 */ {
     26, 27, 28,  0,  0, 29,  7,  7,  0, 30, 31, 32,  0, 33, /*   0- 13 */
      7,  7,  7,  7, 34,  0, 35, 36, 37,  0,  0, 38, 39, 40, /*  14- 27 */
      6,  6,  6,  6,  6,  6,  6,  6,  0, 41, 42,  0,  0, 43, /*  28- 41 */
     44,  0, 45, 46,  7,  7,  7,  7, 47, 48, 49, 50, 51,  0, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      7,  7,  7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  7,  7,  7,  7,  6,  6,  6,  6, /*  98-111 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 112-125 */
      5,  5, 26, 27, 28,  0,  0, 29,  7,  7,  0, 30, 31, 32, /* 126-139 */
      0, 33,  7,  7,  7,  7, 34,  0, 35, 36, 37,  0,  0, 38, /* 140-153 */
     39, 40,  6,  6,  6,  6,  6,  6,  6,  6,  0, 41, 42,  0, /* 154-167 */
      0, 43, 44,  0, 45, 46,  7,  7,  7,  7, 47, 48, 49, 50, /* 168-181 */
     51,  0,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 196-209 */
      6,  6,  7,  7,  7,  7,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      5,  5,  5,  5,  5,  5,  5,  5,  7,  7,  7,  7,  6,  6, /* 224-237 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 238-251 */
      5,  5,  5,  5
},
/* prefix 2 */ {
     52, 53, 54,  0, 55, 56, 57,  0,  0, 58, 59, 60, 61, 62, /*   0- 13 */
      7,  7,  7,  7, 63, 64, 65, 66, 67,  0,  0, 68, 69, 70, /*  14- 27 */
      6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /*  28- 41 */
      0,  0,  6,  6,  6,  6,  6,  6,  6,  6,  0,  0,  7,  7, /*  42- 55 */
      6,  6,  6,  6,  6,  6,  6,  6, 52, 53, 54,  0, 55, 56, /*  56- 69 */
     57,  0,  0, 58, 59, 60, 61, 62,  7,  7,  7,  7, 63, 64, /*  70- 83 */
     65, 66, 67,  0,  0, 68, 69, 70,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  7,  7,  7,  7,  7,  7,  0,  0,  6,  6,  6,  6, /*  98-111 */
      6,  6,  6,  6,  0,  0,  7,  7,  6,  6,  6,  6,  6,  6, /* 112-125 */
      6,  6, 52, 53, 54,  0, 55, 56, 57,  0,  0, 58, 59, 60, /* 126-139 */
     61, 62,  7,  7,  7,  7, 63, 64, 65, 66, 67,  0,  0, 68, /* 140-153 */
     69, 70,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  0,  0,  6,  6,  6,  6,  6,  6,  6,  6,  0,  0, /* 168-181 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6, 52, 53, 54,  0, /* 182-195 */
     55, 56, 57,  0,  0, 58, 59, 60, 61, 62,  7,  7,  7,  7, /* 196-209 */
     63, 64, 65, 66, 67,  0,  0, 68, 69, 70,  6,  6,  6,  6, /* 210-223 */
      6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  0,  0,  6,  6, /* 224-237 */
      6,  6,  6,  6,  6,  6,  0,  0,  7,  7,  6,  6,  6,  6, /* 238-251 */
      6,  6,  6,  6
},
/* prefix 3 */ {
     71, 72, 73, 74, 75, 76, 77,  0,  0, 78, 79, 80, 81, 82, /*   0- 13 */
      7,  7,  7,  7,  0,  0,  0, 83,  7,  7,  7,  7, 84,  0, /*  14- 27 */
      7,  7,  7,  7, 71, 72, 73, 74, 75, 76, 77,  0,  0, 78, /*  28- 41 */
     79, 80, 81, 82,  7,  7,  7,  7,  0,  0,  0, 83,  7,  7, /*  42- 55 */
      7,  7, 84,  0,  7,  7,  7,  7, 71, 72, 73, 74, 75, 76, /*  56- 69 */
     77,  0,  0, 78, 79, 80, 81, 82,  7,  7,  7,  7,  0,  0, /*  70- 83 */
      0, 83,  7,  7,  7,  7, 84,  0,  7,  7,  7,  7, 71, 72, /*  84- 97 */
     73, 74, 75, 76, 77,  0,  0, 78, 79, 80, 81, 82,  7,  7, /*  98-111 */
      7,  7,  0,  0,  0, 83,  7,  7,  7,  7, 84,  0,  7,  7, /* 112-125 */
      7,  7, 71, 72, 73, 74, 75, 76, 77,  0,  0, 78, 79, 80, /* 126-139 */
     81, 82,  7,  7,  7,  7,  0,  0,  0, 83,  7,  7,  7,  7, /* 140-153 */
     84,  0,  7,  7,  7,  7, 71, 72, 73, 74, 75, 76, 77,  0, /* 154-167 */
      0, 78, 79, 80, 81, 82,  7,  7,  7,  7,  0,  0,  0, 83, /* 168-181 */
      7,  7,  7,  7, 84,  0,  7,  7,  7,  7, 71, 72, 73, 74, /* 182-195 */
     75, 76, 77,  0,  0, 78, 79, 80, 81, 82,  7,  7,  7,  7, /* 196-209 */
      0,  0,  0, 83,  7,  7,  7,  7, 84,  0,  7,  7,  7,  7, /* 210-223 */
     71, 72, 73, 74, 75, 76, 77,  0,  0, 78, 79, 80, 81, 82, /* 224-237 */
      7,  7,  7,  7,  0,  0,  0, 83,  7,  7,  7,  7, 84,  0, /* 238-251 */
      7,  7,  7,  7
},
/* prefix 4 */ {
     85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0,  0, 94, /*   0- 13 */
      0,  0, 85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0, /*  14- 27 */
      0, 94,  0,  0, 85, 86, 87, 88, 89, 90, 91,  0,  0, 92, /*  28- 41 */
     93,  0,  0, 94,  0,  0, 85, 86, 87, 88, 89, 90, 91,  0, /*  42- 55 */
      0, 92, 93,  0,  0, 94,  0,  0, 85, 86, 87, 88, 89, 90, /*  56- 69 */
     91,  0,  0, 92, 93,  0,  0, 94,  0,  0, 85, 86, 87, 88, /*  70- 83 */
     89, 90, 91,  0,  0, 92, 93,  0,  0, 94,  0,  0, 85, 86, /*  84- 97 */
     87, 88, 89, 90, 91,  0,  0, 92, 93,  0,  0, 94,  0,  0, /*  98-111 */
     85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0,  0, 94, /* 112-125 */
      0,  0, 85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0, /* 126-139 */
      0, 94,  0,  0, 85, 86, 87, 88, 89, 90, 91,  0,  0, 92, /* 140-153 */
     93,  0,  0, 94,  0,  0, 85, 86, 87, 88, 89, 90, 91,  0, /* 154-167 */
      0, 92, 93,  0,  0, 94,  0,  0, 85, 86, 87, 88, 89, 90, /* 168-181 */
     91,  0,  0, 92, 93,  0,  0, 94,  0,  0, 85, 86, 87, 88, /* 182-195 */
     89, 90, 91,  0,  0, 92, 93,  0,  0, 94,  0,  0, 85, 86, /* 196-209 */
     87, 88, 89, 90, 91,  0,  0, 92, 93,  0,  0, 94,  0,  0, /* 210-223 */
     85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0,  0, 94, /* 224-237 */
      0,  0, 85, 86, 87, 88, 89, 90, 91,  0,  0, 92, 93,  0, /* 238-251 */
      0, 94,  0,  0
},
/* prefix 5 */ {
     95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100, /*   0- 13 */
    101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, /*  14- 27 */
     99,100,101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, /*  28- 41 */
     97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100,101,102, /*  42- 55 */
     95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100, /*  56- 69 */
    101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, /*  70- 83 */
     99,100,101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, /*  84- 97 */
     97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100,101,102, /*  98-111 */
     95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100, /* 112-125 */
    101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, /* 126-139 */
     99,100,101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, /* 140-153 */
     97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100,101,102, /* 154-167 */
     95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100, /* 168-181 */
    101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, /* 182-195 */
     99,100,101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, /* 196-209 */
     97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100,101,102, /* 210-223 */
     95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, 99,100, /* 224-237 */
    101,102, 95, 96, 97, 98, 99,100,101,102, 95, 96, 97, 98, /* 238-251 */
     99,100,101,102
},
/* prefix 6 */ {
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /*   0- 13 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /*  14- 27 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /*  28- 41 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /*  42- 55 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /*  56- 69 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /*  70- 83 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /*  84- 97 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /*  98-111 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /* 112-125 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /* 126-139 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /* 140-153 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /* 154-167 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /* 168-181 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /* 182-195 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /* 196-209 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /* 210-223 */
    103,104,105,106,103,104,105,106,103,104,105,106,103,104, /* 224-237 */
    105,106,103,104,105,106,103,104,105,106,103,104,105,106, /* 238-251 */
    103,104,105,106
},
/* prefix 7 */ {
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*   0- 13 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  14- 27 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  28- 41 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  42- 55 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  56- 69 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  70- 83 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  84- 97 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /*  98-111 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 112-125 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 126-139 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 140-153 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 154-167 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 168-181 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 182-195 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 196-209 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 210-223 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 224-237 */
    107,108,107,108,107,108,107,108,107,108,107,108,107,108, /* 238-251 */
    107,108,107,108
},
/* prefix 8 */ {
    109,110,111,112,  0,113,114,  0,  7,  7,  7,  7,115,116, /*   0- 13 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 9 */ {
    117,118,119,120,  0,  0,121,  0,  7,  7,  7,  7,  6,  6, /*   0- 13 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,117,118,119,120,  0,  0,121,  0,  7,  7,  7,  7, /* 126-139 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 10 */ {
    122,123,124,125,  0,  0,  7,  7,  6,  6,  6,  6,  6,  6, /*   0- 13 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,122,123,124,125,  0,  0, /*  56- 69 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,122,123,124,125,  0,  0,  7,  7,  6,  6,  6,  6, /* 126-139 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,122,123,124,125, /* 182-195 */
      0,  0,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 224-237 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 238-251 */
      4,  4,  4,  4
},
/* prefix 11 */ {
    126,127,128,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /*   0- 13 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,126,127,128,  0,  7,  7,  7,  7,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,126,127,128,  0,  7,  7, /*  56- 69 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,126,127, /*  84- 97 */
    128,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 112-125 */
      5,  5,126,127,128,  0,  7,  7,  7,  7,  6,  6,  6,  6, /* 126-139 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,126,127,128,  0,  7,  7,  7,  7, /* 154-167 */
      6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,126,127,128,  0, /* 182-195 */
      7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
    126,127,128,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /* 224-237 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 238-251 */
      5,  5,  5,  5
},
/* prefix 12 */ {
    129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /*   0- 13 */
      6,  6,129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6, /*  14- 27 */
      6,  6,  6,  6,129,130,  0,  0,  7,  7,  7,  7,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,129,130,  0,  0,  7,  7,  7,  7, /*  42- 55 */
      6,  6,  6,  6,  6,  6,  6,  6,129,130,  0,  0,  7,  7, /*  56- 69 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,129,130,  0,  0, /*  70- 83 */
      7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,129,130, /*  84- 97 */
      0,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
    129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /* 112-125 */
      6,  6,129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6, /* 126-139 */
      6,  6,  6,  6,129,130,  0,  0,  7,  7,  7,  7,  6,  6, /* 140-153 */
      6,  6,  6,  6,  6,  6,129,130,  0,  0,  7,  7,  7,  7, /* 154-167 */
      6,  6,  6,  6,  6,  6,  6,  6,129,130,  0,  0,  7,  7, /* 168-181 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,129,130,  0,  0, /* 182-195 */
      7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,129,130, /* 196-209 */
      0,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6, /* 210-223 */
    129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /* 224-237 */
      6,  6,129,130,  0,  0,  7,  7,  7,  7,  6,  6,  6,  6, /* 238-251 */
      6,  6,  6,  6
},
/* prefix 13 */ {
    131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7, /*   0- 13 */
      7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0, /*  14- 27 */
      7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132, /*  28- 41 */
      0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7, /*  42- 55 */
    131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7, /*  56- 69 */
      7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0, /*  70- 83 */
      7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132, /*  84- 97 */
      0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7, /*  98-111 */
    131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7, /* 112-125 */
      7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0, /* 126-139 */
      7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132, /* 140-153 */
      0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7, /* 154-167 */
    131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7, /* 168-181 */
      7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0, /* 182-195 */
      7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132, /* 196-209 */
      0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7,  7,  7, /* 210-223 */
    131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0,  7,  7, /* 224-237 */
      7,  7,131,132,  0,  0,  7,  7,  7,  7,131,132,  0,  0, /* 238-251 */
      7,  7,  7,  7
},
/* prefix 14 */ {
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /*   0- 13 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /*  14- 27 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /*  28- 41 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /*  42- 55 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /*  56- 69 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /*  70- 83 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /*  84- 97 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /*  98-111 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /* 112-125 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /* 126-139 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /* 140-153 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /* 154-167 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /* 168-181 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /* 182-195 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /* 196-209 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /* 210-223 */
    133,134,  0,  0,133,134,  0,  0,133,134,  0,  0,133,134, /* 224-237 */
      0,  0,133,134,  0,  0,133,134,  0,  0,133,134,  0,  0, /* 238-251 */
    133,134,  0,  0
},
/* prefix 15 */ {
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*   0- 13 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  14- 27 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  28- 41 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  42- 55 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  56- 69 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  70- 83 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  84- 97 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /*  98-111 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 112-125 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 126-139 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 140-153 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 154-167 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 168-181 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 182-195 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 196-209 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 210-223 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 224-237 */
    135,136,135,136,135,136,135,136,135,136,135,136,135,136, /* 238-251 */
    135,136,135,136
},
/* prefix 16 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 126-139 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 140-153 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 154-167 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 168-181 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 182-195 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 196-209 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 210-223 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 224-237 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 238-251 */
      0,  0,  0,  0
},
/* prefix 17 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 224-237 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 238-251 */
      4,  4,  4,  4
},
/* prefix 18 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 19 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 20 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 21 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 22 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 23 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 24 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 25 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 26 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 224-237 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 238-251 */
      5,  5,  5,  5
},
/* prefix 27 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 28 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 29 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 30 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 31 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 32 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 33 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 34 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 35 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 36 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 37 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 38 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 39 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 40 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 41 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 42 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 43 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 44 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 45 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 46 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 47 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 48 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 49 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 50 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 51 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 52 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  4,  4,  4,  4,  4,  4, /*   0- 13 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 112-125 */
      6,  6,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 53 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 54 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 55 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 56 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 57 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 58 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 59 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 60 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 61 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 62 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 63 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 64 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 65 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 66 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 67 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 68 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 69 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 70 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 71 */ {
    137,  0,  7,  7,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /*   0- 13 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /*  28- 41 */
      7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6, /*  42- 55 */
      7,  7,  7,  7,  7,  7,  7,  7,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 72 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 73 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 74 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 75 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 76 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 77 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 78 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 79 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 80 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 81 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 82 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 83 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 84 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 85 */ {
    137,  0,  6,  6,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /*   0- 13 */
      4,  4,  7,  7,  0,  0,  0,  0,  0,  0,  7,  7,  7,  7, /*  14- 27 */
      0,  0,  0,  0,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 86 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 87 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 88 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 89 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 90 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 91 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 92 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 93 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 94 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 95 */ {
    137,  7,  6,  6,  5,  5,  5,  5,  0,138,139,140,  0,  0, /*   0- 13 */
    141,142,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 96 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 97 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  6,  6, /*  84- 97 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 98 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 99 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 100 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 101 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 102 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 103 */ {
    143,  7,  6,  6,144,145,146,147,  6,  6,  6,  6,  6,  6, /*   0- 13 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6, /* 154-167 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 168-181 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 196-209 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 104 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  6,  6, /*  84- 97 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7, /* 140-153 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /* 168-181 */
      7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 105 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 106 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 107 */ {
    148,  7,149,150,  7,  7,  7,  7,  7,  7,  7,  7,  6,  6, /*   0- 13 */
      6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  5,  5,  5,  5, /*  14- 27 */
      5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /*  28- 41 */
      7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  7,  7,  7,  7, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  7,  7,  7,  7,  6,  6,  6,  6,  7,  7,  7,  7, /*  70- 83 */
      7,  7,  7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  7,  7,  7,  7,  0,  0, /* 140-153 */
      0,  0,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  7,  7,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /* 168-181 */
      7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  7,  7,  7,  7,  0,  0,  7,  7,  7,  7, /* 196-209 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  6,  6,  6,  6, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 108 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 109 */ {
    151,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  28- 41 */
     10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  42- 55 */
     10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,  9,  9, /*  56- 69 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  70- 83 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  84- 97 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  98-111 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /* 112-125 */
      9,  9,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 126-139 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 140-153 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 154-167 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 168-181 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 182-195 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 196-209 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 210-223 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 224-237 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 238-251 */
      8,  8,  8,  8
},
/* prefix 110 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 224-237 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 238-251 */
      4,  4,  4,  4
},
/* prefix 111 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 112 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 113 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 114 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 115 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 140-153 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 116 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 117 */ {
    151,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, /*  14- 27 */
     11, 11, 11, 11, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  28- 41 */
     10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  42- 55 */
     10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,  9,  9, /*  56- 69 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  70- 83 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  84- 97 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  98-111 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /* 112-125 */
      9,  9,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 224-237 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 238-251 */
      5,  5,  5,  5
},
/* prefix 118 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6, /* 168-181 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 196-209 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 119 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 120 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 121 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  70- 83 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 140-153 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 154-167 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 168-181 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5, /* 196-209 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 122 */ {
    151,  0,  7,  7,  6,  6,  6,  6, 12, 12, 12, 12, 12, 12, /*   0- 13 */
     12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, /*  14- 27 */
     11, 11, 11, 11, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  28- 41 */
     10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, /*  42- 55 */
     10, 10, 10, 10, 10, 10, 10, 10,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  98-111 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 112-125 */
      6,  6,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /* 140-153 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7, /* 168-181 */
      7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6, /* 196-209 */
      6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  6,  6,  6,  6, /* 210-223 */
      6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /* 224-237 */
      7,  7,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 238-251 */
      4,  4,  4,  4
},
/* prefix 123 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 140-153 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 154-167 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /* 168-181 */
      6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 124 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 125 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  28- 41 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6, /*  70- 83 */
      6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5, /*  84- 97 */
      5,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 126 */ {
    151,  0,  7,  7, 13, 13, 13, 13, 12, 12, 12, 12, 12, 12, /*   0- 13 */
     12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, /*  14- 27 */
     11, 11, 11, 11,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7, /*  28- 41 */
      7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6, /*  42- 55 */
      7,  7,  7,  7,  7,  7,  7,  7,  5,  5,  5,  5,  5,  5, /*  56- 69 */
      5,  5,  7,  7,  0,  0,  0,  0,  7,  7,  7,  7,  0,  0, /*  70- 83 */
      0,  0,  7,  7,  7,  7,  0,  0,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  0,  0,  7,  7,  7,  7,  7,  7,  0,  0,  7,  7, /*  98-111 */
      7,  7,  0,  0,  0,  0,  0,  0,  5,  5,  5,  5,  5,  5, /* 112-125 */
      5,  5,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /* 168-181 */
      7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /* 196-209 */
      7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  6,  6,  6,  6, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 127 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 126-139 */
      4,  4,  4,  4,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7, /* 140-153 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7, /* 154-167 */
      7,  7,  7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  7,  7, /* 168-181 */
      7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 128 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 129 */ {
    151,  0, 14, 14, 13, 13, 13, 13, 12, 12, 12, 12, 12, 12, /*   0- 13 */
     12, 12,  7,  7,  0,  0,  0,  0,  0,  0,  7,  7,  7,  7, /*  14- 27 */
      0,  0,  0,  0,  6,  6,  6,  6,  0,152,153,  0,  0,154, /*  28- 41 */
    155,  0,  0,156,  7,  7,  7,  7,157,  0,  0,  0,158,  0, /*  42- 55 */
      0,159,160,161,  6,  6,  6,  6,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  7,  7,  0,  0, /*  70- 83 */
      0,  0,  0,  0,  0,  0,  0,  0,  6,  6,  6,  6,  6,  6, /*  84- 97 */
      6,  6,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  7, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  5,  5,  5,  5, /* 182-195 */
      5,  5,  5,  5,  0,  0,  0,  0,  0,  0,  7,  7,  7,  7, /* 196-209 */
      0,  0,  0,  0,  0,  0,  7,  7,  0,  0,  6,  6,  6,  6, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 130 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 131 */ {
    151, 15, 14, 14, 13, 13, 13, 13,  0,162,163,164,  0,  0, /*   0- 13 */
    165,166,  7,  7,167,168,169,170,171,  0,  0,172,173,174, /*  14- 27 */
    175,176,  7,  7,  5,  5,  5,  5,  5,  5,  5,  5,  0,177, /*  28- 41 */
    178,179,180,181,  7,  7,  7,  7,182,183,184,185,186,  0, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  6,  6, /*  84- 97 */
      6,  6,187,188,189,  0,  0,190,191,192,  0,193,  7,  7, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 132 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 133 */ {
    194, 15, 14, 14,195,196,197,198,  0,199,200,201,202,203, /*   0- 13 */
    204,  0,  6,  6,  6,  6,205,206,207,  0,  0,208,209,210, /*  14- 27 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  7,  7,211,212,213,214,215,  0, /*  42- 55 */
      5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 134 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 135 */ {
    216, 15,217,218,219,220,221,222,  7,  7,223,224,225,226, /*   0- 13 */
      7,  7,  6,  6,  6,  6,  6,  6,  6,  6,  0,227,228,229, /*  14- 27 */
      6,  6,  6,  6,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, /*  28- 41 */
      5,  5,  5,  5,  5,  5,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 136 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 137 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 138 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 139 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 140 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 141 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 142 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 143 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 126-139 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 140-153 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 154-167 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 168-181 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 182-195 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 196-209 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 210-223 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 224-237 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 238-251 */
      0,  0,  0,  0
},
/* prefix 144 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 145 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 146 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 147 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 148 */ {
    137,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 126-139 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 140-153 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 154-167 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 168-181 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 182-195 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 196-209 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 210-223 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 224-237 */
      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* 238-251 */
      0,  0,  0,  0
},
/* prefix 149 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 150 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 151 */ {
    151,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 152 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 153 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 154 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 155 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 156 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 157 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 158 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 159 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 160 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 161 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 162 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 163 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 164 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 165 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 166 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 167 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 168 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 169 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 170 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 171 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 172 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 173 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 174 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 175 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 176 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 177 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 178 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 179 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 180 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 181 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 182 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 183 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 184 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 185 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 186 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 187 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 188 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 189 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 190 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 191 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 192 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 193 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 194 */ {
    151,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 126-139 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 140-153 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 154-167 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 168-181 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 182-195 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 196-209 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 210-223 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 224-237 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 238-251 */
      8,  8,  8,  8
},
/* prefix 195 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 196 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 197 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 198 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 199 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 200 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 201 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 202 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 203 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 204 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 205 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 206 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 207 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 208 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 209 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 210 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 211 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 212 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 213 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 214 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 215 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 126-139 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 140-153 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 154-167 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 168-181 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 216 */ {
    151,  0,  7,  7,  6,  6,  6,  6,  5,  5,  5,  5,  5,  5, /*   0- 13 */
      5,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  14- 27 */
      4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  9,  9,  9,  9,  9,  9, /*  56- 69 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  70- 83 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  84- 97 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /*  98-111 */
      9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, /* 112-125 */
      9,  9,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 126-139 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 140-153 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 154-167 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 168-181 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 182-195 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 196-209 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 210-223 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 224-237 */
      8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, /* 238-251 */
      8,  8,  8,  8
},
/* prefix 217 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 218 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  56- 69 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  70- 83 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  84- 97 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  98-111 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 112-125 */
      2,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 219 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 220 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4, /* 154-167 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 168-181 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 221 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4, /* 182-195 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 196-209 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 222 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  28- 41 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  42- 55 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  56- 69 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  70- 83 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  84- 97 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /*  98-111 */
      4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4, /* 112-125 */
      4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 223 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 224 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
},
/* prefix 225 */ {
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*   0- 13 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  14- 27 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  28- 41 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  42- 55 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  56- 69 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  70- 83 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  84- 97 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /*  98-111 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 112-125 */
      1,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 226 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 227 */ {
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*   0- 13 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  14- 27 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  28- 41 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  42- 55 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2, /* 182-195 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 196-209 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 210-223 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 224-237 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /* 238-251 */
      2,  2,  2,  2
},
/* prefix 228 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 126-139 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 140-153 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 154-167 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 168-181 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 182-195 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 196-209 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 210-223 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 224-237 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 238-251 */
      3,  3,  3,  3
},
/* prefix 229 */ {
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*   0- 13 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  14- 27 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  28- 41 */
      2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, /*  42- 55 */
      2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3, /*  56- 69 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  70- 83 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  84- 97 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /*  98-111 */
      3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, /* 112-125 */
      3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 126-139 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 140-153 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 154-167 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 168-181 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 182-195 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 196-209 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 210-223 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 224-237 */
      1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, /* 238-251 */
      1,  1,  1,  1
}
};
